hash_size = 10

letter_list ='abcdefghijkimnopqrstvuwxyz'

prime_list = [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101]

assert len(letter_list)==len(prime_list)

letter_to_prime = dict(zip(letter_list, prime_list))

def simple_hash_fn(x):
    """
    The suggested hash_function.
    """
    x = x.lower()
    terms = []
    for let in x:
        terms.append(letter_to_prime[let])
    return sum(terms) % hash_size
assert simple_hash_fn('bag')==2

print('Exercise 5.5 items hashed to the indices:')
print(list(map(simple_hash_fn, 'Esther Ben Bob Dan'.split())))

print('Exercise 5.6 items hashed to the indices:')
print(list(map(simple_hash_fn, 'A AA AAA AAAA'.split())))

print('Exercise 5.7 items hashed to the indices:')
print(list(map(simple_hash_fn, 'Maus Fun Home Watchmen'.split())))

